import { __assign, __spreadArray } from "tslib";
import { useState, useCallback } from "react";
import _ from "lodash";
export var useMultiSelect = function () {
    var _a = useState({}), objStore = _a[0], setObjStore = _a[1];
    var _b = useState([]), storeKeys = _b[0], setStoreKeys = _b[1];
    var _c = useState([]), selectedKeys = _c[0], setSelectedKeys = _c[1];
    var hasKey = useCallback(function (key) { return _.has(objStore, key); }, [objStore]);
    var addObjToStore = useCallback(function (obj, keyPrefix) {
        if (keyPrefix === void 0) { keyPrefix = ""; }
        var key = "" + _.toString(Date.now());
        if (keyPrefix)
            key = keyPrefix + "_" + key;
        setObjStore(function (prevStore) {
            var _a;
            return (__assign(__assign({}, prevStore), (_a = {}, _a[key] = obj, _a)));
        });
        setStoreKeys(function (prevKeys) { return _.uniq(__spreadArray(__spreadArray([], prevKeys), [key])); });
        return key;
    }, [setObjStore, setStoreKeys]);
    var delObjFromStore = useCallback(function (key) {
        setObjStore(function (prevStore) { return _.omit(prevStore, key); });
        setStoreKeys(function (prevState) { return _.pull(prevState, key); });
        setSelectedKeys(function (prevState) { return _.pull(prevState, key); });
    }, [setObjStore, setStoreKeys, setSelectedKeys]);
    var delAllObjs = useCallback(function () {
        setObjStore({});
        setStoreKeys([]);
        setSelectedKeys([]);
    }, [setObjStore, setStoreKeys, setSelectedKeys]);
    var selectObj = useCallback(function (key) {
        if (hasKey(key))
            setSelectedKeys(function (prevState) { return _.uniq(__spreadArray(__spreadArray([], prevState), [key])); });
    }, [setSelectedKeys, hasKey]);
    var unSelectObj = useCallback(function (key) {
        setSelectedKeys(function (prevState) { return _.uniq(_.pull(__spreadArray([], prevState), key)); });
    }, [setSelectedKeys]);
    var selectAll = useCallback(function () {
        setSelectedKeys(storeKeys);
    }, [setSelectedKeys, storeKeys]);
    var unSelectAll = useCallback(function () {
        setSelectedKeys([]);
    }, [setSelectedKeys]);
    return {
        objStore: objStore,
        storeKeys: storeKeys,
        selectedKeys: selectedKeys,
        addObjToStore: addObjToStore,
        delObjFromStore: delObjFromStore,
        delAllObjs: delAllObjs,
        selectObj: selectObj,
        unSelectObj: unSelectObj,
        selectAll: selectAll,
        unSelectAll: unSelectAll,
    };
};
